\environment entorn

<%
require_relative 'biblioteca'

%>

\starttext

\startsubject[title={Paràmetres de centralització}]

\startsubsubject[title={Preguntes}]

<%

exercicis = Hash.new
enunciats = Hash.new

%>


<%# Exercici 1 %>
<%
exercicis[1] = Array.new

# Ha de ser múltiple de 15: 1..16 o 1..31 o ....
for i in (0...30)  
  exercicis[1].push(rand(0..6))
end
%>

\startexercici[reference=exercici-1] En un centre d'adults s'enregistren el nombre d'assignatures aprovades per part de l'alumnat. Es pren una mostra aleatòria de <%= exercicis[1].length %> persones. Els resultats són els següents (vegeu taula~\in[taula:exercicis-automatics-estadistica-1]).

\startplacetable[location=force, reference=taula:exercicis-automatics-estadistica-1, title={Nombre d'assignatures aprovades d'un total de sis possibles.}]
\bTABLE[frame=off,align={flushleft,lohi},width=fit, offset=2mm]
 <% exercicis[1].each_with_index do |p, i| %>
   <% if (i % 15) == 0%>
   \bTR
   <% end %>
   
   \bTD <%=p%>,\eTD
   
   <% if (i % 15) == 0%>
   \eTR
   <% end %>
 <% end %>
\eTABLE
\stopplacetable

Amb aquestes dades:
\startitemize[a]
\item Feis la taula de freqüències
\item Calculeu la mitjana aritmètica, la mediana i la moda
\item Interpreteu els paràmetres anteriors.
\item Si el centre té 300 persones matriculades, quantes persones és d'esperar que aprovin totes les assignatures?
\stopitemize

\stopexercici



<%# Exercici 2 %>
<%
exercicis[2] = Array.new
talla = ["XS", "S", "M", "L", "XL"]

for i in (0...60)
  exercicis[2].push(talla[rand(0..4)])
end

%>


\startexercici[reference=exercici-2] Durant l'inventari d'una tenda de roba, s'enregistren les talles de les camisetes (vegeu taula~\in[taula:exercicis-automatics-estadistica-2]):

\startplacetable[location=force, reference=taula:exercicis-automatics-estadistica-2, title={Talles de camisetes}]
\startalignment[center]
<%= exercicis[2].join(", ") %>.
\stopalignment
\stopplacetable

\startitemize[a]
\item Quina talla de camiseta és la més abundant?
\item Calculeu el percentatge que representa cada talla respecte del total
\item Podeu calcular la mitjana, la mediana i la moda de les dades anteriors? Per què?
\item Sabem que el cost de tintada de cada camiseta és $XS \mapsto \text{2 €}$, $S \mapsto \text{2,20 €}$, $M \mapsto \text{2,50 €}$, $L \mapsto \text{2,80 €}$ i $XL \mapsto \text{3,50 €}$. Trobeu el cost mitjà de tintada d'una camiseta triada a l'atzar.
\stopitemize
\stopexercici

<%# Exercici 3 %>
<%
exercicis[3] = Array.new
for i in (0...60)
  exercicis[3].push(rand(0..4))
end

parents = ["germans", "cosins", "oncles", "nets"]
enunciats[3] = Array.new

enunciats[3].push(parents[rand(0..3)])


%>


\startexercici[reference=exercici-3] Es fa una enquesta i s’enregistra el nombre de <%=enunciats[3][0]%> de <%=exercicis[3].size%> persones (vegeu taula~\in[taula:exercicis-automatics-estadistica-3]):

\startplacetable[location=force, reference=taula:exercicis-automatics-estadistica-3, title={Nombre de <%=enunciats[3][0]%>}]
\bTABLE[frame=off,align={flushleft,lohi},width=fit, offset=2mm]
 <% exercicis[3].each_with_index do |p, i| %>
   <% if (i % 15) == 0%>
   \bTR
   <% end %>
   
   \bTD <%=p%>,\eTD
   
   <% if (i % 15) == 0%>
   \eTR
   <% end %>
 <% end %>
\eTABLE
\stopplacetable

\startitemize[a]
\item Feis una taula de freqüències
\item Calculeu la mitjana aritmètica i interpreteu-la
\stopitemize
\stopexercici



<%# Exercici 4 %>
<%
# Cercam una dimensió del nombre de dades múltiple de 15
dimensio = 15*rand(1..5)

# Prenem unes dades aleatòries
exercicis[4] = Array.new
for i in (0...dimensio)
  exercicis[4].push(rand(0..4))
end
%>


\startexercici[reference=exercici-4] El nombre d’hores setmanals d’exercici de <%=exercicis[4].size%> persones, arrodonides a les unitats, són les següents (taula~\in[taula:exercicis-automatics-estadistica-4]):

\startplacetable[location=force, reference=taula:exercicis-automatics-estadistica-4, title={Nombre de <%=enunciats[3][0]%>}]
\bTABLE[frame=off,align={flushleft,lohi},width=fit, offset=2mm]
 <% exercicis[4].each_with_index do |p, i| %>
   <% if (i % 15) == 0%>
   \bTR
   <% end %>
   
   \bTD <%=p%>,\eTD
   
   <% if (i % 15) == 0%>
   \eTR
   <% end %>
 <% end %>
\eTABLE
\stopplacetable

\startitemize[a]
\item Calculeu la moda i la mediana
\item Interpreteu els resultats
\stopitemize
\stopexercici

\stopsubsubject

<%# ----------------------- Solucions ------------------------ %>
\page[yes]
\startsubsubject[title={Solucions}]

\startitemize
\sym{\in[exercici-1]}
\startitemize[a]
\item 
\startplacetable[location={force,none}, reference=taula:exercicis-automatics-exercici1-solucions, title={Taula de freqüències absolutes}]
\bTABLE[frame=on,align={middle,lohi},width=fit, offset=2mm]
 \bTR[background=color, backgroundcolor=tablecolor, color=black, align={middle,lohi},style=ss,headstyle=ss]
   \bTH Assignatures aprovades \eTH
   \bTH Freqüència \eTH
 \eTR
 <% Estadistica.taula_frequencies(exercicis[1]).each do |valor, freq| %>
 \bTR
   \bTD <%= valor %> \eTD
   \bTD <%= freq %> \eTD
 \eTR
 <% end %>
 \eTABLE
\stopplacetable

\item $\overline{x} = \frac{<%=exercicis[1].sum%>}{<%=exercicis[1].length%>} \simeq <%= (exercicis[1].sum/(exercicis[1].length.to_f)).round(3) %>$; $Me = <%=Estadistica.mediana(exercicis[1])%>$; $Mo = <%= Estadistica.moda(exercicis[1]) %>$.

\item Si totes les persones haguessin aprovat el mateix nombre d'assignatures, aquest seria $<%= (exercicis[1].sum/(exercicis[1].length.to_f)).round(3) %>$; El més freqüent és aprovar <%=Estadistica.moda(exercicis[1], cadenaformat=" o ")%> assignatures; El 50\% de les persones aprova $<%=Estadistica.mediana(exercicis[1])%>$ o menys.

\item Hi hauria $<%= Estadistica.taula_frequencies(exercicis[1])[6].to_f/exercicis[1].length * 300 %>$ persones amb totes les assignatures aprovades.
\stopitemize

\sym{\in[exercici-2]}
\startitemize[a]
\item La talla de camisetes més abundant és $Mo = <%= Estadistica.moda(exercicis[2]) %>$.
\item Els percentatges que representa cada talla, arrodonits a les dècimes, són:

\startplacetable[location={force,none}, reference=taula:exercicis-automatics-exercici2-solucions, title={Taula de percentatges}]
\bTABLE[frame=on,align={middle,lohi},width=fit, offset=2mm]
 \bTR[background=color, backgroundcolor=tablecolor, color=black, align={middle,lohi},style=ss,headstyle=ss]
   \bTH Talla \eTH
   \bTH Percentatge \eTH
 \eTR
 <% Estadistica.taula_frequencies_relatives(exercicis[2]).each do |valor, freq| %>
 \bTR
   \bTD <%= valor %> \eTD
   \bTD <%= (freq*100).round(1) %> \eTD
 \eTR
 <% end %>
 \eTABLE
\stopplacetable

\item No podem calcular ni la mitjana ni la mediana però sí la moda. Perquè la variable no és numèrica.

\item 

<% taulafreq = Estadistica.taula_frequencies(exercicis[2]) %>
<%

preumitja = 0

taulafreq.each do |valor, freq|
   if valor == 'XS'
      preumitja = preumitja + 2*freq
   elsif valor == 'S'
      preumitja = preumitja + 2.20*freq
   elsif valor == 'M'
      preumitja = preumitja + 2.50*freq
   elsif valor == 'L'
      preumitja = preumitja + 2.80*freq
   elsif valor == 'XL'
      preumitja = preumitja + 3.50*freq
   end
end

preumitja = (preumitja/exercicis[2].length).round(2)
%>

El preu mitjà és <%=preumitja%>€.


\stopitemize

\sym{\in[exercici-3]}
\startitemize[a]
\item La taula de freqüències és

\startplacetable[location={force,none}, reference=taula:exercicis-automatics-exercici3-solucions, title={Taula de freqüències}]
\bTABLE[frame=on,align={middle,lohi},width=fit, offset=2mm]
 \bTR[background=color, backgroundcolor=tablecolor, color=black, align={middle,lohi},style=ss,headstyle=ss]
   \bTH Talla \eTH
   \bTH Freqüència \eTH
 \eTR
 <% Estadistica.taula_frequencies(exercicis[3]).each do |valor, freq| %>
 \bTR
   \bTD <%= valor %> \eTD
   \bTD <%= freq %> \eTD
 \eTR
 <% end %>
 \eTABLE
\stopplacetable


\item 

\stopitemize La mitjana és <%=Estadistica.mitjana(exercicis[3])%>. Això vol dir que, si totes les persones enquestades tenguessin el mateix nombre de cosins, llavors tendrien <%=Estadistica.mitjana(exercicis[3])%> cosins cadascú.

\sym{\in[exercici-4]}
\startitemize[a]
\item La moda és $Mo = <%=Estadistica.moda(exercicis[4])%>$ i la mediana $Me = <%=Estadistica.mediana(exercicis[4])%>$.
\item El més freqüent és fer <%=Estadistica.moda(exercicis[4])%> hores d'exercici. El 50\% de les persones fa <%=Estadistica.mediana(exercicis[4])%> hores d'exercici o menys.
\stopitemize


\stopitemize

\vfill
Les solucions d'aquests exercicis s'han calculat automàticament usant programari lliure: encara que totes les expressions són correctes, potser algunes es poden simplificar més.

\stopsubsubject

<%# ----------------------- Resolució ------------------------ %>
\page[yes]
\startsubsubject[title={Resolució}]

\startitemize
\sym{\in[exercici-1]}\startitemize[a]
\item Per fer la taula de freqüències (absolutes), hem de recomptar les dades, és a dir, hem de fer una taula amb dues columnes: en la primera hi haurà el nombre d'assignatures que es poden aprovar, és a dir, un nombre entre 0 i 6. En la segona columna hi haurà el nombre de persones que han aprovat cada nombre d'assignatures concret.

\startplacetable[location={force,none}, reference=taula:exercicis-automatics-exercici1-solucions, title={Taula de freqüències absolutes}]
\bTABLE[frame=on,align={middle,lohi},width=fit, offset=2mm]
 \bTR[background=color, backgroundcolor=tablecolor, color=black, align={middle,lohi},style=ss,headstyle=ss]
   \bTH Assignatures aprovades \eTH
   \bTH Freqüència \eTH
 \eTR
 <% Estadistica.taula_frequencies(exercicis[1]).each do |valor, freq| %>
 \bTR
   \bTD <%= valor %> \eTD
   \bTD <%= freq %> \eTD
 \eTR
 <% end %>
 \bTR[background=color, backgroundcolor=tablecolor, color=black, align={middle,lohi},style=ss,headstyle=ss]
   \bTD Total \eTD
   \bTD <%= exercicis[1].length %> \eTD
 \eTR
 \eTABLE
\stopplacetable

\item
\startitemize[A]
\item Per a calcular la mitjana aritmètica, hem de sumar totes les dades i dividir pel total de dades. En el nostre cas, $\overline{x} = \frac{<%=exercicis[1].sum%>}{<%=exercicis[1].length%>} \simeq <%= (exercicis[1].sum/(exercicis[1].length.to_f)).round(3) %>$.

\item La mediana és el valor d'enmig de la mostra. Sabem que hi ha $<%=exercicis[1].length%>$ valors: <% if exercicis[1].length.odd? %> és senar. Per tant, hem de prendre el valor <%=exercicis[1].length/2 + 1%>è, és a dir, <%=exercicis[1].sort[exercicis[1].length/2]%><% else %> és parell. Per tant, hem de prendre els valors <%=exercicis[1].length/2%>è i <%=exercicis[1].length/2+1%>è, és a dir, <%=exercicis[1].sort[exercicis[1].length/2-1]%> i <%=exercicis[1].sort[exercicis[1].length/2]%>, i fer la seva mitjana aritmètica<% end %>.

Amb tot, $Me = <%=Estadistica.mediana(exercicis[1])%>$.

\item La moda és el valor més freqüent.
En el nostre cas, $Mo = <%= Estadistica.moda(exercicis[1]) %>$.
\stopitemize

\item Si totes les persones haguessin aprovat el mateix nombre d'assignatures, aquest seria $<%= (exercicis[1].sum/(exercicis[1].length.to_f)).round(3) %>$; El més freqüent és aprovar <%=Estadistica.moda(exercicis[1], cadenaformat=" o ")%> assignatures; El 50\% de les persones aprova $<%=Estadistica.mediana(exercicis[1])%>$ o menys.

\item Si hi hagués 300 persones matriculades, podríem extrapolar el nombre de persones que aprovarien sis assignatures usant proporcionalitat numèrica, és a dir, una regla de tres directa:

\startitemize[packed]
\item Si en <%=exercicis[1].length%> persones, n'hi ha <%=Estadistica.taula_frequencies(exercicis[1])[6] %> que han aprovat sis assignatures 
\item Quantes persones aprovarien sis assignatures amb un total de 300 persones?
\stopitemize

<%
aprovats = Estadistica.taula_frequencies(exercicis[1])[6] 
%>

La resposta seria $\frac{<%=aprovats%>}{<%=exercicis[1].length%>} \cdot 300 = <%= aprovats.to_f/exercicis[1].length * 300 %>$
\stopitemize


\sym{\in[exercici-2]}

\startitemize[a]
\item La talla de camisetes més abundant realment és la moda de les talles de les camisetes. $Mo = <%= Estadistica.moda(exercicis[2]) %>$
\item La taula de freqüències de les talles és:

\startplacetable[location={force,none}, reference=taula:exercicis-automatics-exercici2-solucions-a, title={Taula de freqüències}]
\bTABLE[frame=on,align={middle,lohi},width=fit, offset=2mm]
 \bTR[background=color, backgroundcolor=tablecolor, color=black, align={middle,lohi},style=ss,headstyle=ss]
   \bTH Talla \eTH
   \bTH Freqüències \eTH
 \eTR
 <% Estadistica.taula_frequencies(exercicis[2]).each do |valor, freq| %>
 \bTR
   \bTD <%= valor %> \eTD
   \bTD <%= freq %> \eTD
 \eTR
 <% end %>
 \eTABLE
\stopplacetable

Per tant, fent una regla de tres, podem saber els percentatges que representa cada talla (el 100\% són <%=exercicis[2].size%> dades). Els percentatges estan arrodonits a les dècimes:

\startplacetable[location={force,none}, reference=taula:exercicis-automatics-exercici2-solucions, title={Taula de percentatges}]
\bTABLE[frame=on,align={middle,lohi},width=fit, offset=2mm]
 \bTR[background=color, backgroundcolor=tablecolor, color=black, align={middle,lohi},style=ss,headstyle=ss]
   \bTH Talla \eTH
   \bTH Percentatge \eTH
 \eTR
 <% Estadistica.taula_frequencies_relatives(exercicis[2]).each do |valor, freq| %>
 \bTR
   \bTD <%= valor %> \eTD
   \bTD <%= (freq*100).round(1) %> \eTD
 \eTR
 <% end %>
 \eTABLE
\stopplacetable


\item No podem calcular ni la mitjana ni la mediana, ja que la variable de les talles de les camisetes és qualitativa i no quantitativa. És a dir, les talles de les camisetes no són nombres, sinó paraules. Per tant, no les podem ordenar per a calcular la mediana\footnote{Encara que admetem que podem ordenar paraules, per exemple amb l'ordre lexicogràfic, recordeu que en el cas parell, hem de prendre la mitjana aritmètica dels valors centrals, cosa que no podem fer.} ni molt menys sumar i dividir. Sí que podem trobar la moda, ja que només hem de calcular la taula de freqüències absolutes, cosa que podem fer independentment de com sigui la variable.

\item Realment, el que hauríem de fer és una mitjana aritmètica d'una sèrie de dades en les que cada talla és substituïda pel seu preu.

<% taulafreq = Estadistica.taula_frequencies(exercicis[2]) %>
<%

preumitja = 0

taulafreq.each do |valor, freq|
   if valor == 'XS'
      preumitja = preumitja + 2*freq
   elsif valor == 'S'
      preumitja = preumitja + 2.20*freq
   elsif valor == 'M'
      preumitja = preumitja + 2.50*freq
   elsif valor == 'L'
      preumitja = preumitja + 2.80*freq
   elsif valor == 'XL'
      preumitja = preumitja + 3.50*freq
   end
end

preumitja = (preumitja/exercicis[2].length).round(2)
%>

D'aquesta manera, obtenim un preu mitjà arrodonit de <%=preumitja%>€.


\stopitemize

\sym{\in[exercici-3]}
\startitemize[a]
\item La taula de freqüències és

\startplacetable[location={force,none}, reference=taula:exercicis-automatics-exercici3-solucions, title={Taula de freqüències}]
\bTABLE[frame=on,align={middle,lohi},width=fit, offset=2mm]
 \bTR[background=color, backgroundcolor=tablecolor, color=black, align={middle,lohi},style=ss,headstyle=ss]
   \bTH Talla \eTH
   \bTH Freqüència \eTH
 \eTR
 <% Estadistica.taula_frequencies(exercicis[3]).each do |valor, freq| %>
 \bTR
   \bTD <%= valor %> \eTD
   \bTD <%= freq %> \eTD
 \eTR
 <% end %>
 \eTABLE
\stopplacetable


\item La mitjana és <%=Estadistica.mitjana(exercicis[3])%>. Això vol dir que, si totes les persones enquestades tenguessin el mateix nombre de cosins, llavors tendrien <%=Estadistica.mitjana(exercicis[3])%> cosins cadascú.

\stopitemize 

\sym{\in[exercici-4]}
\startitemize[a]
\item La taula de freqüències és

\startplacetable[location={force,none}, reference=taula:exercicis-automatics-exercici4-solucions, title={Taula de freqüències}]
\bTABLE[frame=on,align={middle,lohi},width=fit, offset=2mm]
 \bTR[background=color, backgroundcolor=tablecolor, color=black, align={middle,lohi},style=ss,headstyle=ss]
   \bTH Talla \eTH
   \bTH Freqüència \eTH
 \eTR
 <% Estadistica.taula_frequencies(exercicis[4]).each do |valor, freq| %>
 \bTR
   \bTD <%= valor %> \eTD
   \bTD <%= freq %> \eTD
 \eTR
 <% end %>
 \eTABLE
\stopplacetable

Per tant, la moda és $Mo = <%=Estadistica.moda(exercicis[4])%>$.

Per calcular la moda hem de notar que el nombre total de dades, $<%= exercicis[4].size %>$, <% if exercicis[4].size.odd? %>és senar<% else %>és parell <% end %>. Per tant, <% if exercicis[4].size.odd? %>hem de prendre la dada <%=exercicis[4].size/2%>a<%else%>hem de calcular la mitjana aritmètica de la dada <%= exercicis[4].length/2-1 %>a i <%=exercicis[4].length/2%>a, que és $\frac{<%=exercicis[4].sort[exercicis[4].length/2-1]%>+<%=exercicis[4].sort[exercicis[4].length/2]%>}{2}$ <% end %>. Per tant, la mediana $Me = <%=Estadistica.mediana(exercicis[4])%>$.
\item El més freqüent és fer <%=Estadistica.moda(exercicis[4])%> hores d'exercici.

El 50\% de les persones fa <%=Estadistica.mediana(exercicis[4])%> hores d'exercici o menys. O sigui, en el nostre cas, ja que només comptam hores senceres, el 50\% de les persones fa <%= (0..(Estadistica.mediana(exercicis[4])-1)).to_a.join(", ") %> o <%=Estadistica.mediana(exercicis[4])%> hores d'exercici.
\stopitemize

\stopitemize

\vfill
La resolució d'aquests exercicis s'ha calculat automàticament usant programari lliure: encara que totes les expressions són correctes, potser algunes es poden simplificar més.

\stopsubsubject

\stopsubject

\stoptext
